<!DOCTYPE html>
<html>
  <head>
    <title>FarmBuddy Sensor Data</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.4/Chart.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/flatpickr/dist/flatpickr.min.css">
  </head>
  <body>
    <label for="date-picker">Select Date:</label>
    <input type="text" id="date-picker">

    <canvas id="myChart"></canvas>

    <script>
   function getData(startDate, endDate) {
  let url = '/data';
  if (startDate && endDate) {
    url += `?start=${startDate}&end=${endDate}`;
  }
  
  fetch(url)
    .then(res => res.json())
    .then(data => {
      const labels = data.map(obj => obj.msg.device_id);
      const tempData = data.map(obj => obj.msg.temp);
      const humidData = data.map(obj => obj.msg.humid);
      const heatIndexData = data.map(obj => obj.msg.heatIndex);
      const datetimeData = data.map(obj => new Date(obj.timestamp).toLocaleString());
      const idData = data.map(obj => obj.msg.gateway);

      const ctx = document.getElementById('myChart').getContext('2d');
      const chart = new Chart(ctx, {
        type: 'bar',
        data: {
          labels: datetimeData,
          datasets: [
            {
              label: 'Temperature (C)',
              data: tempData,
              backgroundColor: 'rgba(255, 99, 132, 0.2)',
              borderColor: 'rgba(255, 99, 132, 1)',
              borderWidth: 1
            },
            {
              label: 'Humidity (%)',
              data: humidData,
              backgroundColor: 'rgba(54, 162, 235, 0.2)',
              borderColor: 'rgba(54, 162, 235, 1)',
              borderWidth: 1
            },
            {
              label: 'Heat Index (C)',
              data: heatIndexData,
              backgroundColor: 'rgba(255, 206, 86, 0.2)',
              borderColor: 'rgba(255, 206, 86, 1)',
              borderWidth: 1
            }
          ]
        },
        options: {
          scales: {
            yAxes: [{
              ticks: {
                beginAtZero: true
              }
            }],
            xAxes: [{
              ticks: {
                autoSkip: true,
                maxTicksLimit: 20
              }
            }]
          },
          tooltips: {
            callbacks: {
              label: function(tooltipItem, data) {
                var label = data.datasets[tooltipItem.datasetIndex].label || '';
                if (label) {
                  label += ': ';
                }
                label += tooltipItem.yLabel;
                if (tooltipItem.datasetIndex == 0) {
                  label += 'C';
                } else if (tooltipItem.datasetIndex == 1) {
                  label += '%';
                }
                return label;
              }
            }
          }
        }
      });
    });
}

// Example usage: filter data for March 2022
const startDate = '2022-03-01T00:00:00Z';
const endDate = '2022-04-01T00:00:00Z';
getData(startDate, endDate);

    </script>
  </body>
</html>
